NOTICE:

If you recieve an in-game message that says "ERROR ..name.. does not exist. See readme file. " it means you have discovered a mod conflict.  Please report this to the discussion board in the mod portal.  You can eliminate this error and continue your game by adding the name given in the error to the config file under "weartear.do_not_age".  


WEAR AND TEAR


DESCRIPTION OF MOD

This mod adds wear and tear mechanics to the game.  Mining drills, assembling machines, pumpjacks, oils refineries, chemical plants, steam engines and solar panels all age and degrade over time.  Machines added by other mods also age as well.    Machines that run constantly age faster than machines that are idle.

There are 4 stages of wear:

new:  		runs normally
aging: 		minor speed penalty and emits a little more pollution
old: 		significant speed penalty and double pollution.
dilapidated:	crippling speed penalty and massive pollution.  Stops working completely after a while.

You will receive a notification whenever a machine ages.  This notification can be toggled off in the config file.

The stage of aging, old and dilapidated machines are shown in the name of the entity in the information panel.  Old machines periodically emit smoke and dilapidated machines emit a lot of smoke.

If you remove a new machine from the ground, it will become "aging."  If you remove an aging machine from the ground, it becomes "old".   So you are penalized a little for moving stuff around.  Plan before you place.

Old machines can be recycled for 50% of the ingredients used to create a brand new machine.  

If you remove a dilapidated machine, it becomes a pile of scrap metal, which can be smelted into iron plates.

If you leave leave a dilapidated machine for too long there is a chance it will explode. (can be toggled off in the config file settings)

You can configure the intervals for each stage of wear in the config file.  The default is 60 minutes for each stage, for a machine that is running continuously.  Idle machines can last up to 4 times longer, depending on use.  So under the default settings, a machine will last anywhere between 4 and 16 hours before it stops working, although you'll probably want to replace after 2-3 hours.

You can also configure which machines types age. 


AUTOMATION:

Old or dilapidated machines will automatically be removed and replaced by your construction bots.  You can configure which machines (or none) are to be automatically replaced in the config file.  To make sure a machine gets replaced, you must: (a) make sure the machine is inside a logistics network (the orange zone) (b) Have a suitable replacement item in a provider or storage chest.  Bots will scan roughly every 15 seconds for old equipment.  When found, they will take the following steps:  

1.  Tag the equipment for deconstruction.
2.  Deconstruct the machine, placing the machine and all its contents in storage.
3.  Retrieve a new machine and place it at the location of the old one.
4. The orientation and any recipes from the old machine will be automatically transferred to the new machine.  


COMPATIBILITY:

I've tested it extensively with Bobs and Angels. Let me know if you encounter any problems.  

RECOMMENDED OTHER MODS

In addition to Bobs and Angels, I highly recommend using this with my other mod "10x Harder" as the two mods work together to change the "purpose" of your factory.  In vanilla and most mods, the purpose of your factory is just to build science kits and do research, since the cost in resources of building the new machines needed to expand is trivial.  But with these two mods working together, the purpose of your factories is to both produce science AND to maintain a steady supply of resources and machinery needed to expand and maintain your base.    You'll need proper a factory and transportation network in order to keep things running smoothly and to grow your base.


CHANGE LOG:

1.0.10

- Fixed issue with replaced assemblers using fluid inputs not getting properly oriented by the bots
- Fixed issue where aging was happening faster then intended and getting multiplied by the number of players.  
- Added smoke effects to old and dilapidated machines  (can be turned off in the config file)

1.0.9

- When bots replace an old entity with modules, the modules are now transferred to the new entity
- Fixed issue where recycling was yielding 100% of the original ingredients.  It's now always 50% as intended
- The qty of scrap metal from dilapidated entities is now 50% of total ingredients for original recipe.  (was always 200)
- Improved algorithm for bot replacement of old entities.   Bots will now compare the available parts to "claimed-parts" (parts already needed on another old entity) before starting a new work order.  This should prevent situations where multiple old entities are competing for the same replacement part, leading to "hanging ghosts".  Also, this change allowed me to remove the "one at a time" limitation.  Thus bot replacement is now much faster and more robust.
- Added internal cleanup utility to bot replacement work-orders.  Work orders older than 5 minutes are automatically purged.  This is to prevent problems where the player interferes with a bot replacement by manually deleting a ghost, blocking the build location, etc.

1.0.8

- Fixed bug caused by changing config to disable aging on certain machines and then loading an old game
- Added in-game notifications for whenever config settings are changed.
- Note:  If you have "aging", "old" or "dilapidated" machines on a save game and then change settings to no longer age those machines, they  will still be in the game.  They just won't age any further.  You can recycle if you want to get rid of them.
- Fixed problems with hand-crafting formulas confused due to recycling recipes

1.0.7 

- Optimized code for significant performance improvement, especially on large factories.  
- Extended wear and tear mechanics to solar panels and steam engines.
- You can now configure which machines age in the config file.
- There's now a chance that Dilapidated machines left unattended for too long will explode.  This can be toggled off in the config settings.

1.0.6 Fixed issue related to 1.0.5

1.0.5 Fixed typo that was causing a crash when a mod creates a recipe with a different name than the entity it creates.

1.0.4 Added error checking to make sure recycle recipes have at least one product.  (should fix problem with Angel's heavy pump)

1.0.3 Added full automation of aging equipment using the logistics network.  Fixed issue where oil refineries (and possibly other machines) were losing recipes when aging.

1.0.1 Made moving new equipment less punishing.  Removing new equipment now yields "aging" equipment.  Moving aging equipment yields "old" equipment.  Also removed the hard dependency on the uranium ore mod.

1.0.0 Initial version
