local weartear = {}


-- ADVANCED SETTINGS 

--  List of specific entities to not age.  This will cause the mod to ignore any entity with these names.  Use mainly to address mod conflicts and prevent errors. Note that adding to this list will also cause "aging" versions of those entities to disappear from any saved game.

weartear.do_not_age = {"burner-turbine-generator", "assembling-machine-dynamic", "assembling-machine-dynamic-2", "chemical-plant-dynamic", "vehicle-miner-attachment", "vehicle-miner-mk2-attachment", "vehicle-miner-mk3-attachment", "vehicle-miner-mk4-attachment", "vehicle-miner-mk5-attachment", "solaire-power", "wind-turbine", "droid-assembling-machine", "droid-guard-station", "reverse-factory", "bi_solar-panel_for_Bio_Farm"}



-- material durability bonuses is time added to entities using these metals the recipe.  The material can be in anything (gears, plates, pipe, etc).  The game will simply scan the recipe ingredients for words in this table.  Bonuses are a percentage of the total aging time. (e.g. nitinol gets a 100% durability bonus). Note material bonuses do not stack.

weartear.material_bonuses = {
	{name = "iron", bonus = 0},
	{name = "steel", bonus = .2},
	{name = "invar", bonus = .4},
	{name = "glass", bonus = .4},
	{name = "silver", bonus = .4},
	{name = "aluminium", bonus = .6},
	{name = "titanium", bonus = .6},
	{name = "tungsten", bonus = .8},
	{name = "nitinol", bonus = 1}
}


-- add special bonuses here for specific entities.  Format should be same as the material_bonuses table. {{name = _____, bonus = _}}  Must use the EXACT name as it is set up in the prototype (not the localized name)

weartear.special_bonuses = {{name = "put-entity-name-here", bonus = 0}} 


return weartear
