weartear = require("config")

require "util"
require "control-wt"
require "control-evo"
require "gui.control-gui"

local function onRobot_Mined(event)
	weartear.onRobot_Mined(event)
end
	
local function onRobot_Built(event)
	weartear.onRobot_Built(event)
end


local function onPlayer_Built(event)
	weartear.onPlayer_Built(event)
end

local function onPreMine(event)
	weartear.onPreMine(event)
end
	
local function onTick(event) 
	weartear.onTick(event)
	gui.onTick(event)
	evo_onTick(event) 
end

local function onInit() 
	weartear.onInit()
	gui.mod_init()
	evo_onInit()
end

local function onModSettingsChange(event)
	weartear.onModSettingsChange(event)
end

local function onConfigurationChanged(data)
	weartear.onInit()
end

local function onPlayerCreated(event)
	gui.onPlayerCreated(event)
end

local function onGuiClick(event)
	gui.onGuiClick(event)
end
function weartear.get_age(entity)
  local age
  for _, roster_entry in pairs(global.roster) do
    if roster_entry.entity.valid == true then
      if (roster_entry.entity.position.x == entity.position.x and roster_entry.entity.position.y == entity.position.y) then age = (weartear.old_age - roster_entry.age) end
    end
  end    
  return age  
end
function weartear.set_age(entity, age)  
  for _, roster_entry in pairs(global.roster) do
    if roster_entry.entity.valid == true then
      if (roster_entry.entity.position.x == entity.position.x and roster_entry.entity.position.y == entity.position.y) then roster_entry.age = age end
    end
  end    
end
remote.add_interface("weartear", {get_age = weartear.get_age, set_age = weartear.set_age})

script.on_event(defines.events.on_tick, onTick)
script.on_event(defines.events.on_robot_pre_mined, onRobot_Mined)
script.on_event(defines.events.on_robot_built_entity, onRobot_Built)
script.on_event(defines.events.on_built_entity, weartear.onPlayer_Built)
--script.on_event(defines.events.on_preplayer_mined_item, weartear.onPreMine)
script.on_event("check_age", weartear.check_age)
script.on_event("toggle_vent", weartear.toggle_vent)
script.on_init(onInit)
script.on_configuration_changed(onConfigurationChanged)
script.on_event(defines.events.on_runtime_mod_setting_changed, onModSettingsChange)
script.on_event(defines.events.on_player_created, onPlayerCreated)
script.on_event(defines.events.on_gui_click, onGuiClick)
script.on_event(defines.events.on_rocket_launched, evo_onRocketLaunched)

