require "util"
require ("category")
require ("alien-drops")
weartear = require("config")
require ("localized-name-translations")
require ("prototypes.smoke_builder")
weartear.new_mod = {settings.startup.new_mod_speed.value,settings.startup.new_mod_pollution.value}
weartear.aging_mod = {settings.startup.aging_mod_speed.value, settings.startup.aging_mod_pollution.value}
weartear.old_mod = {settings.startup.old_mod_speed.value,settings.startup.old_mod_pollution.value}
weartear.dilapidated_mod = {settings.startup.dilapidated_mod_speed.value,settings.startup.dilapidated_mod_pollution.value}
weartear.last_recipe = nil
if HarderA then 
	goop_amount = HarderA.factor * 5
	data.raw.recipe["machinery_lubricant"].results = {{type="fluid", name="liquified-goop", amount=goop_amount}}
	data.raw.recipe["machinery_lubricant"].ingredients = {{"alien-goop", 1}, {type="fluid", name = "water", amount = goop_amount}}
end
if data.raw.fluid["water-purified"] then data.raw.recipe["machinery_lubricant"].ingredients[2].name = "water-purified" end
if data.raw.roboport["construction-roboport"] then data.raw.roboport["construction-roboport"].construction_radius = 40 end
if data.raw.fluid["water-yellow-waste"] then 
	data.raw.recipe["copper_sulfate"].ingredients = {{"sulfur", 1}, {"copper-ore", 2}, {type="fluid", name = "water-purified", amount = 10}} 
	data.raw.recipe["copper_sulfate"].results= {{type="item", name="copper-dust", amount=10},{type="fluid", name="water-yellow-waste", amount=2}}
end
data.raw.pipe.pipe.pictures.ending_up.filename = "__WearAndTear__/graphics/entity/pipe/pipe-ending-up.png"
data.raw.pipe.pipe.pictures.ending_up.hr_version.filename = "__WearAndTear__/graphics/entity/pipe/hr-pipe-ending-up.png"
data.raw.pipe.pipe.pictures.ending_down.filename = "__WearAndTear__/graphics/entity/pipe/pipe-ending-down.png"
data.raw.pipe.pipe.pictures.ending_down.hr_version.filename = "__WearAndTear__/graphics/entity/pipe/hr-pipe-ending-down.png"
data.raw.pipe.pipe.pictures.ending_right.filename = "__WearAndTear__/graphics/entity/pipe/pipe-ending-right.png"
data.raw.pipe.pipe.pictures.ending_right.hr_version.filename = "__WearAndTear__/graphics/entity/pipe/hr-pipe-ending-right.png"
data.raw.pipe.pipe.pictures.ending_left.filename = "__WearAndTear__/graphics/entity/pipe/pipe-ending-left.png"
data.raw.pipe.pipe.pictures.ending_left.hr_version.filename = "__WearAndTear__/graphics/entity/pipe/hr-pipe-ending-left.png"


local function nerf_solar(production, reduction)
	local lfv = string.len (production)
	local endpoint = lfv - 2
	local original_numerical = string.sub(production, 1, endpoint)
	local original_as_number = tonumber(original_numerical)
	local new_value = original_as_number * reduction
	local new_power = (new_value .. "kW")
	return new_power
end

local function get_results_count(r_name, table)
	local amount = 1
	for i, result in pairs(table) do
		if result.name == r_name then amount = result.amount end
	end
	return amount
end

local function get_plates_count(r_name)
	local recipe_list = data.raw.recipe[r_name].ingredients
	local break_loop = false
	if data.raw.recipe[r_name].normal then recipe_list = data.raw.recipe[r_name].normal.ingredients end
	local plates = 0
	local result_magnifier = 1
	if data.raw.recipe[r_name].result_count then result_magnifier = data.raw.recipe[r_name].result_count end
	if data.raw.recipe[r_name].results then result_magnifier = get_results_count(r_name, data.raw.recipe[r_name].results) end -- if there's multiple results, get the count for the one named in the recipe
	for j, ingredient in pairs(recipe_list) do
		if ingredient.name then
			i_name = ingredient.name
			i_amount = ingredient.amount
		end
		if ingredient[1] then
			i_name = ingredient[1]
			i_amount = ingredient[2]
		end
		if i_name == "catalyst-metal-carrier" then i_amount = 0 end
		if i_name == weartear.last_recipe then break_loop = true log ("stack-overflow countermeasures activated on ".. i_name) end
		weartear.last_recipe = r_name
		if string.find(i_name, "plate") 
			then plates = plates + (i_amount / result_magnifier) 
		else
--			if (data.raw.recipe[i_name] and not(i_name == "solid-sodium")) then plates = plates + (i_amount * get_plates_count(i_name) / result_magnifier) end
			if (data.raw.recipe[i_name] and break_loop == false) then plates = plates + (i_amount * get_plates_count(i_name) / result_magnifier) end
		end
	end
	--log ("Returning " .. plates .. " plates for " .. r_name)
	return plates
end


local function get_refurbish_ingredients(r_name, r_amount)
	weartear.last_recipe = nil
	local ingredient = "spare_parts"
	local m1 = 1 / 5.5 -- Using a value of 5.5 plates per spare part  (2 copper, 3 iron, .5 lead/tin)
	local m2 = 0
	if string.find(r_name, "plate") then 
		m2 = 1 
	else
		if data.raw.recipe[r_name] then 
			--log ("Getting plate count for " .. r_name)
			m2 = get_plates_count(r_name) 
		end 
	end
	local ingredient_amount = math.ceil(r_amount * m1 * m2)
	--log ("returning " .. ingredient_amount .. " spare parts for " .. r_name)
	return ingredient, ingredient_amount
end

function recipe_builder(old_item, entity_name, recipe_name, recipe_list)
	local r_results = {}
	local ref_results = {}
	local refurbish_ingredients = {}
	table.insert(refurbish_ingredients, {type = "item", name = old_item.name, amount = 1})
	table.insert(refurbish_ingredients, {type = "item", name = "spare_parts", amount = 1})
	table.insert(ref_results, {type = "item", name = entity_name, amount = 1})
	table.insert(ref_results, {type = "item", name = "scrap-metal", amount = 0})
	local total_ingredient_count = 0
	local r_name
	local r_amount
	local ref_name
	local ref_amount
	log("Building refurbish recipe for " .. old_item.name)
	for j, ingredient in pairs(recipe_list) do
		if ingredient.name then
			r_name = ingredient.name
			r_amount = ingredient.amount * .5
		end
		if ingredient[1] then
			r_name = ingredient[1]
			r_amount = ingredient[2] * .5
		end
		--log ("Getting spare parts for ingredient " .. r_name)
		ref_name, ref_amount = get_refurbish_ingredients(r_name, r_amount)
		if ref_name == "spare_parts" then 
			refurbish_ingredients[2]["amount"] = refurbish_ingredients[2]["amount"] + ref_amount 
			ref_results[2]["amount"] = ref_results[2]["amount"] + ref_amount 
		end
		r_amount = math.ceil(r_amount)  -- randomly up, if 1 then we'll give it a 50/50 chance. 
		if r_amount > 0 then
			if r_amount == 1 then 
				table.insert(r_results, {type = "item", name = r_name, amount_min = 1, amount_max = 1, probability = .5})
			else 
        local stack_size = 50 -- needs to initiate with a non-nil value since (annoyingly) not all ingredients are items or fluids.  
        local r = 1
        local rs_amount = r_amount
        if data.raw.item[r_name] then stack_size = data.raw.item[r_name].stack_size end
        if data.raw.module[r_name] then stack_size = data.raw.module[r_name].stack_size end
        repeat
          if rs_amount > stack_size then r = r + 1 rs_amount = rs_amount / r end
        until rs_amount <= stack_size
        for x=1, r do
          table.insert(r_results, {type = "item", name = r_name, amount = rs_amount})
        end
      end
			total_ingredient_count = total_ingredient_count + r_amount
		end
	end
	if total_ingredient_count > 0 then table.insert(r_results, {type = "item", name = "scrap-metal", amount = total_ingredient_count}) end
	if total_ingredient_count == 0 then table.insert(r_results, {type = "item", name = "iron-plate", amount = 1}) end -- give this recipe at least one product
	return r_results,refurbish_ingredients, ref_results
end

local function create_new_library(type, entity_name, recipe_name)
      -- Create aging copies of the entity.  These will be swapped into the game via script when factories age
        local aging_entity = util.table.deepcopy(data.raw[type][entity_name]) 
            aging_entity.name = ("Aging_" .. aging_entity.name)
            aging_entity.localised_name = {"weartear.aging", {"entity-name."..data.raw[type][entity_name].name}}
         local m_result = ("Aging_" .. entity_name) 
         aging_entity.minable.result = m_result 
         if aging_entity.crafting_speed then aging_entity.crafting_speed = aging_entity.crafting_speed * weartear.aging_mod[1] end
         if aging_entity.mining_speed then aging_entity.mining_speed = aging_entity.mining_speed * weartear.aging_mod[1] end
         if aging_entity.effectivity then aging_entity.effectivity = aging_entity.effectivity * weartear.aging_mod[1] end
         if aging_entity.production then aging_entity.production = nerf_solar(aging_entity.production, weartear.aging_mod[1]) end
         if aging_entity.energy_source.emissions then aging_entity.energy_source.emissions = aging_entity.energy_source.emissions * weartear.aging_mod[2] end     
         data:extend({aging_entity})
            -- aging item
         local aging_item = util.table.deepcopy(data.raw.item[entity_name]) 
         aging_item.localised_name = {"weartear.aging", {"entity-name."..data.raw[type][entity_name].name}}
         aging_item.name = ("Aging_" .. aging_item.name)
         aging_item.place_result = aging_item.name
         table.insert(aging_item.flags, "hidden")
         data:extend({aging_item})
      local old_entity = util.table.deepcopy(data.raw[type][entity_name])
         old_entity.name = ("Old_" .. old_entity.name)
         old_entity.localised_name = {"weartear.old", {"entity-name."..data.raw[type][entity_name].name}}
         if old_entity.crafting_speed then old_entity.crafting_speed = old_entity.crafting_speed * weartear.old_mod[1] end
         if old_entity.mining_speed then old_entity.mining_speed = old_entity.mining_speed * weartear.old_mod[1] end
         if old_entity.effectivity then old_entity.effectivity = old_entity.effectivity * weartear.old_mod[1] end
         if old_entity.production then old_entity.production = nerf_solar(old_entity.production, weartear.old_mod[1]) end
         if old_entity.energy_source.emissions then old_entity.energy_source.emissions = old_entity.energy_source.emissions * weartear.old_mod[2] end
         local m_result = ("Old_" .. entity_name) 
         old_entity.minable.result = m_result  -- if you remove it, it stays old   
         data:extend({old_entity})
            -- old item
         local old_item = util.table.deepcopy(data.raw.item[entity_name])
         old_item.localised_name = {"weartear.old", {"entity-name."..data.raw[type][entity_name].name}}
         old_item.name = ("Old_" .. old_item.name)
         old_item.place_result = old_item.name
         data:extend({old_item})
         -- make recipe's to recycle.refurbush the old item
         local r_icon = old_item.icon
         local r_icons = old_item.icons
         recycle_name = ("Recycle " .. old_item.name)
         refurbish_name = ("Refurbish " .. old_item.name)
         recycle_loc_name = {"weartear.recycle", {"weartear.old", {"entity-name."..data.raw[type][entity_name].name}}}
         refurbish_loc_name = {"weartear.refurbish", {"weartear.old", {"entity-name."..data.raw[type][entity_name].name}}}
         if data.raw.recipe[recipe_name].normal then 
            -- BUILD NORMAL AND EXPENSIVE RECIPES
            local normal_recipe_list = data.raw.recipe[recipe_name].normal.ingredients 
            local expensive_recipe_list = data.raw.recipe[recipe_name].expensive.ingredients 
            local normal_r_results, normal_refurbish_ingredients, normal_ref_results = recipe_builder(old_item, entity_name, recipe_name, normal_recipe_list)
            local expensive_r_results,expensive_refurbish_ingredients, expensive_ref_results = recipe_builder(old_item, entity_name, recipe_name, expensive_recipe_list)
            local recycle_normal = {energy_required = 5, enabled = true, ingredients = {{old_item.name, 1}}, results = normal_r_results}
            local recycle_expensive = {energy_required = 5, enabled = true, ingredients = {{old_item.name, 1}}, results = expensive_r_results}
            local refurbish_normal = {energy_required = 5, enabled = true, ingredients = normal_refurbish_ingredients, results = normal_ref_results}
            local refurbish_expensive = {energy_required = 5, enabled = true, ingredients = expensive_refurbish_ingredients, results = expensive_ref_results}
            data:extend({{type = "recipe", category = "recycling", name = recycle_name, localised_name = recycle_loc_name, subgroup = "recycling", normal = recycle_normal, expensive = recycle_expensive, icon = r_icon, icons = r_icons, order = "a", icon_size = 32
}})
            data:extend({{type = "recipe", category = "refurbishing", name = refurbish_name, localised_name = refurbish_loc_name, subgroup = "refurbishing", energy_required = 5, enable = true, normal = refurbish_normal, expensive = refurbish_expensive, icon = r_icon, icons = r_icons, order = "a", icon_size = 32
}})
            if settings.startup.hide_refurbush_recipes.value == true then 
            	data.raw.recipe[recycle_name].normal.hidden = true
            	data.raw.recipe[recycle_name].expensive.hidden = true
            	data.raw.recipe[refurbish_name].normal.hidden = true
            	data.raw.recipe[refurbish_name].expensive.hidden = true
            end
         end
         if data.raw.recipe[recipe_name].ingredients then 
            -- BUILD REGULAR RECIPE
            local recipe_list = data.raw.recipe[recipe_name].ingredients 
            local r_results, refurbish_ingredients, ref_results = recipe_builder(old_item, entity_name, recipe_name, recipe_list)
            data:extend({{type = "recipe", category = "recycling", name = recycle_name, localised_name = recycle_loc_name, subgroup = "recycling", energy_required = 5, enabled = true, ingredients = {{old_item.name, 1}}, results = r_results, icon = r_icon, icons = r_icons, order = "a", icon_size = 32
}})
            data:extend({{type = "recipe", category = "refurbishing", name = refurbish_name, localised_name = refurbish_loc_name, subgroup = "refurbishing", energy_required = 5, enable = true, ingredients = refurbish_ingredients, results = ref_results, icon = r_icon, icons = r_icons, order = "a", icon_size = 32
}})
            if settings.startup.hide_refurbush_recipes.value == true then 
            	data.raw.recipe[recycle_name].hidden = true
            	data.raw.recipe[refurbish_name].hidden = true
            end
         end
      local dilapidated_entity = util.table.deepcopy(data.raw[type][entity_name])
         dilapidated_entity.name = ("Dilapidated_" .. dilapidated_entity.name)
         local total_ingredient_count = 0
         local recipe_list = data.raw.recipe[recipe_name].ingredients
         if data.raw.recipe[recipe_name].normal then recipe_list = data.raw.recipe[recipe_name].normal.ingredients end
         if data.raw.recipe[recipe_name].expensive then recipe_list = data.raw.recipe[recipe_name].expensive.ingredients end
         for j, ingredient in pairs(recipe_list) do
               local r_amount = 0
               if ingredient.name then r_amount = math.floor(ingredient.amount * .5) end
               if ingredient[1] then r_amount = math.floor(ingredient[2] * .5) end
               total_ingredient_count = total_ingredient_count + r_amount
         end
         if total_ingredient_count == 0 then total_ingredient_count = 1 end -- make sure it's at least one.
         dilapidated_entity.minable.results = {{type = "item", name = "scrap-metal", amount = total_ingredient_count}}
         dilapidated_entity.localised_name = {"weartear.dilapidated", {"entity-name."..data.raw[type][entity_name].name}}
         if dilapidated_entity.crafting_speed then dilapidated_entity.crafting_speed = dilapidated_entity.crafting_speed * weartear.dilapidated_mod[1] end
         if dilapidated_entity.mining_speed then dilapidated_entity.mining_speed = dilapidated_entity.mining_speed * weartear.dilapidated_mod[1] end
         if dilapidated_entity.effectivity then dilapidated_entity.effectivity = dilapidated_entity.effectivity * weartear.dilapidated_mod[1] end
         if dilapidated_entity.production then dilapidated_entity.production = nerf_solar(dilapidated_entity.production, weartear.dilapidated_mod[1]) end
         if dilapidated_entity.energy_source.emissions then dilapidated_entity.energy_source.emissions = dilapidated_entity.energy_source.emissions * weartear.dilapidated_mod[2] end
         data:extend({dilapidated_entity})
         local dilapidated_item = util.table.deepcopy(data.raw.item[entity_name])
         dilapidated_item.name = ("Dilapidated_" .. dilapidated_item.name)
         dilapidated_item.localised_name = {"weartear.dilapidated", {"entity-name."..data.raw[type][entity_name].name}}
         dilapidated_item.place_result = dilapidated_item.name
         data:extend({dilapidated_item}) -- never used.  we only need this to prevent an error.
-- Now modify the regular version of this entity
      if data.raw[type][entity_name].crafting_speed then data.raw[type][entity_name].crafting_speed = data.raw[type][entity_name].crafting_speed * weartear.new_mod[1] end
      if data.raw[type][entity_name].mining_speed then data.raw[type][entity_name].mining_speed = data.raw[type][entity_name].mining_speed * weartear.new_mod[1] end
      if data.raw[type][entity_name].effectivity then data.raw[type][entity_name].effectivity = data.raw[type][entity_name].effectivity * weartear.new_mod[1] end
      if data.raw[type][entity_name].production then data.raw[type][entity_name].production = nerf_solar(data.raw[type][entity_name].production, weartear.new_mod[1]) end
      if data.raw[type][entity_name].energy_source.emissions then data.raw[type][entity_name].energy_source.emissions = data.raw[type][entity_name].energy_source.emissions * weartear.new_mod[2] end
      data.raw[type][entity_name].localised_name = {"weartear.new", {"entity-name."..data.raw[type][entity_name].name}}
end


	
for i, entity in pairs(data.raw.recipe) do -- get all assembling machines
	local entity_name = entity.result
	if entity.results then 
		if entity.results[1] then entity_name = entity.results[1].name end
	end
	if entity.normal then
		if entity.normal.result then entity_name = entity.normal.result end
		if entity.normal.results then 
			if entity.normal.results[1] then entity_name = entity.normal.results[1].name end
		end
	end
	local recipe_name = entity.name
	local create = true
	for j, list in ipairs(weartear.do_not_age) do
		if list == entity_name then create = false end
	end
	if string.find(entity.name, "Recycle") then create = false end
	if string.find(entity.name, "Refurbish") then create = false end
	if (data.raw["assembling-machine"][entity_name] and create == true) then create_new_library("assembling-machine", entity_name, recipe_name) end
	if (data.raw["mining-drill"][entity_name] and create == true) then create_new_library("mining-drill", entity_name, recipe_name) end
	if (data.raw["generator"][entity_name] and create == true) then create_new_library("generator", entity_name, recipe_name) end
	if (data.raw["solar-panel"][entity_name] and create == true) then create_new_library("solar-panel", entity_name, recipe_name) end
	if ((data.raw["furnace"][entity_name] and create == true) and data.raw["furnace"][entity_name].energy_source.type == "electric") then create_new_library("furnace", entity_name, recipe_name) end
end




