gui = {}


function gui.Play_Sound(player)
	player.surface.create_entity{name="click", position=player.position}
end


function update_gui()
	if critical_research_progress == nil then evo.set_critical_research_progress() end
	global.gui_settings = global.gui_settings or {}
	local status_caption = {"gui-caption.nothing"}
	local style = "label"
	local evolution = game.forces["enemy"].evolution_factor
	if global.evolution_suppression <= .5 then status_caption = {"gui-caption.nothing"} end
	if global.evolution_suppression > .5 then 
		status_caption = {"gui-caption.slowed"} 
	end
	if global.evolution_suppression >= 1 and (evolution >= global.critical_research_progress) then 
		status_caption = {"gui-caption.stopped"} 
	end
	if global.evolution_suppression >= 1 and (evolution < global.critical_research_progress) then 
		status_caption = {"gui-caption.resisting"} 
		style = "orange_font"
	end
	local fill_bar = global.evolution_suppression
	if fill_bar > 1 then fill_bar = 1 end
	for i, player in pairs(game.players) do
		if global.gui_settings[player.name] == nil then
			gui.create_gui(player)
		end
		local button = player.gui.top.gui_root.evolution_inhibitor_button
		if (global.evolution_suppression < 1 and global.evolution_suppression > .50) then button.style = "toxin_info_button_yellow" end        
    	if global.evolution_suppression < .5  then button.style = "toxin_info_button_red" end   
    	if global.evolution_suppression > 1 and (evolution >= global.critical_research_progress) then button.style = "toxin_info_button_green" end        
		if global.evolution_suppression > 1 and (evolution < global.critical_research_progress) then button.style = "toxin_info_button_orange" end        
		if global.gui_settings[player.name] == "opened" then
			player.gui.top.gui_root.status_frame.inhibitor_progress_label.caption = status_caption
			player.gui.top.gui_root.status_frame.inhibitor_progress_label.style = style
			player.gui.top.gui_root.status_frame.inhibitor_progress.value = fill_bar
		end
	end
end

function gui.create_gui(player)
	global.gui_settings =  global.gui_settings or {}
	global.gui_settings[player.name] = "closed"
    local root = player.gui.top.gui_root
    local destroyed = false
    if root then
        player.gui.top.gui_root.destroy()
        destroyed = true
    end
    if not root or destroyed then
        local root = player.gui.top.add{type="frame", name="gui_root", direction="horizontal"}
        local button = root.add{type="button", name="evolution_inhibitor_button", style="toxin_info_button_green"}
        if (global.evolution_suppression < 1 and global.evolution_suppression > .50) then button.style = "toxin_info_button_yellow" end        
        if global.evolution_suppression < .5  then button.style = "toxin_info_button_red" end        
    end
end



function gui.onTick(event)
	if (event.tick % 125 == 0) then 
		update_gui()		
	end
end

function gui.onGuiClick(event)
	if critical_research_progress == nil then evo.set_critical_research_progress() end
	local player = game.players[event.player_index]
	if event.element.name ==  "evolution_inhibitor_button"  then
		gui.Play_Sound(player)
		if global.gui_settings[player.name] == "closed" then -- toggle setting
			global.gui_settings[player.name] = "opened" 
			player.gui.top.gui_root.add{type="frame", name="status_frame", direction="vertical", style="outer_frame"}
			local status_caption = {"gui-caption.nothing"}
			local style = "label"
			local evolution = game.forces["enemy"].evolution_factor
			if global.evolution_suppression <= .5 then status_caption = {"gui-caption.nothing"} end
			if global.evolution_suppression > .5 then 
				status_caption = {"gui-caption.slowed"} 
			end
			if global.evolution_suppression >= 1 and (evolution >= global.critical_research_progress) then 
				status_caption = {"gui-caption.stopped"} 
			end
			if global.evolution_suppression >= 1 and (evolution < global.critical_research_progress) then 
				status_caption = {"gui-caption.resisting"} 
				style = "orange_font"
			end
			local fill_bar = global.evolution_suppression
			if fill_bar > 1 then fill_bar = 1 end
			player.gui.top.gui_root.status_frame.add{type="label", style = style, name="inhibitor_progress_label", caption = status_caption}
			player.gui.top.gui_root.status_frame.add{type="progressbar", name="inhibitor_progress", style="toxin_progressbar", value = fill_bar, size = 1}
		else
			global.gui_settings[player.name] = "closed"
			player.gui.top.gui_root.status_frame.destroy() 			
		end
	end
end

function gui.mod_init()
	for i, player in pairs(game.players) do
		gui.create_gui(player)
	end
end

function gui.onPlayerCreated(event)
	gui.create_gui(game.players[event.player_index])
	
end

