
local recycler_entity = util.table.deepcopy(data.raw["assembling-machine"]["assembling-machine-2"])
local recycler_item = util.table.deepcopy(data.raw.item["assembling-machine-2"]) 
recycler_entity.name = "recycler"
recycler_entity.minable.result = "recycler" 
recycler_item.name = "recycler"
recycler_entity.crafting_categories = {"recycling"}
recycler_item.place_result = "recycler"
data:extend({recycler_entity})
data:extend({recycler_item})


local refurbisher_entity = util.table.deepcopy(data.raw["assembling-machine"]["assembling-machine-2"])
local refurbisher_item = util.table.deepcopy(data.raw.item["assembling-machine-2"]) 
refurbisher_entity.name = "refurbisher"
refurbisher_entity.minable.result = "refurbisher" 
refurbisher_entity.crafting_categories = {"refurbishing"}
refurbisher_item.name = "refurbisher"
refurbisher_item.place_result = "refurbisher"
data:extend({refurbisher_entity})
data:extend({refurbisher_item})

local scanner_entity = util.table.deepcopy(data.raw["constant-combinator"]["constant-combinator"])
local scanner_item = util.table.deepcopy(data.raw.item["constant-combinator"]) 
scanner_entity.name = "scanner"
scanner_entity.minable.result = "scanner" 
scanner_item.name = "scanner"
scanner_item.place_result = "scanner"
data:extend({scanner_entity})
data:extend({scanner_item})

local emitter_entity = util.table.deepcopy(data.raw["boiler"]["boiler"])
local emitter_item = util.table.deepcopy(data.raw.item["boiler"]) 
emitter_entity.name = "emitter"
emitter_entity.minable.result = "emitter" 
emitter_item.name = "emitter"
emitter_item.icon = "__WearAndTear__/graphics/icons/boiler-alien.png"
emitter_item.place_result = "emitter_closed"
emitter_entity.fluid_input =
    {
      name = "alien-solution",
      amount = 10.0
    }
emitter_entity.fluid_output =
    {
      name = "alien-steam",
      amount = 0
    }
emitter_entity.energy_source.emissions = 0
emitter_entity.energy_source.smoke =
      {
        {
          name = "mist-smoke",
          north_position = util.by_pixel(-38, -47.5),
          south_position = util.by_pixel(38.5, -32),
          east_position = util.by_pixel(20, -70),
          west_position = util.by_pixel(-19, -8.5),
--          frequency = 10 / 32,
          starting_vertical_speed = 0.08,
          slow_down_factor = 1,
          starting_frame_deviation = 60,
          frequency = 15
--          starting_vertical_speed = 0.0,
--          starting_frame_deviation = 60          
        }
      }
      
      
emitter_entity.fire =
    {
      north =
      {
        filename = "__WearAndTear__/graphics/entity/boiler/boiler-N-fire.png",
        priority = "extra-high",
        frame_count = 64,
        line_length = 8,
        width = 12,
        height = 13,
        animation_speed = 0.5,
        shift = util.by_pixel(0, -8.5),
        hr_version = {
          filename = "__WearAndTear__/graphics/entity/boiler/hr-boiler-N-fire.png",
          priority = "extra-high",
          frame_count = 64,
          line_length = 8,
          width = 26,
          height = 26,
          animation_speed = 0.5,
          shift = util.by_pixel(0, -8.5),
          scale = 0.5
        }
      },
      east =
      {
        filename = "__WearAndTear__/graphics/entity/boiler/boiler-E-fire.png",
        priority = "extra-high",
        frame_count = 64,
        line_length = 8,
        width = 14,
        height = 14,
        animation_speed = 0.5,
        shift = util.by_pixel(-10, -22),
        hr_version = {
          filename = "__WearAndTear__/graphics/entity/boiler/hr-boiler-E-fire.png",
          priority = "extra-high",
          frame_count = 64,
          line_length = 8,
          width = 28,
          height = 28,
          animation_speed = 0.5,
          shift = util.by_pixel(-9.5, -22),
          scale = 0.5
        }
      },
      south =
      {
        filename = "__WearAndTear__/graphics/entity/boiler/boiler-S-fire.png",
        priority = "extra-high",
        frame_count = 64,
        line_length = 8,
        width = 12,
        height = 9,
        animation_speed = 0.5,
        shift = util.by_pixel(-1, -26.5),
        hr_version = {
          filename = "__WearAndTear__/graphics/entity/boiler/hr-boiler-S-fire.png",
          priority = "extra-high",
          frame_count = 64,
          line_length = 8,
          width = 26,
          height = 16,
          animation_speed = 0.5,
          shift = util.by_pixel(-1, -26.5),
          scale = 0.5
        }
      },
      west =
      {
        filename = "__WearAndTear__/graphics/entity/boiler/boiler-W-fire.png",
        priority = "extra-high",
        frame_count = 64,
        line_length = 8,
        width = 14,
        height = 14,
        animation_speed = 0.5,
        shift = util.by_pixel(13, -23),
        hr_version = {
          filename = "__WearAndTear__/graphics/entity/boiler/hr-boiler-W-fire.png",
          priority = "extra-high",
          frame_count = 64,
          line_length = 8,
          width = 30,
          height = 29,
          animation_speed = 0.5,
          shift = util.by_pixel(13, -23.25),
          scale = 0.5
        }
      }
    }
   
   
    
    emitter_entity.fire_glow =
    {
      north =
      {
        filename = "__WearAndTear__/graphics/entity/boiler/boiler-N-light.png",
        priority = "extra-high",
        frame_count = 1,
        width = 100,
        height = 87,
        shift = util.by_pixel(-1, -6.5),
        blend_mode = "additive",
        hr_version = {
          filename = "__WearAndTear__/graphics/entity/boiler/hr-boiler-N-light.png",
          priority = "extra-high",
          frame_count = 1,
          width = 200,
          height = 173,
          shift = util.by_pixel(-1, -6.75),
          blend_mode = "additive",
          scale = 0.5
        }
      },
      east =
      {
        filename = "__WearAndTear__/graphics/entity/boiler/boiler-E-light.png",
        priority = "extra-high",
        frame_count = 1,
        width = 70,
        height = 122,
        shift = util.by_pixel(0, -13),
        blend_mode = "additive",
        hr_version = {
          filename = "__WearAndTear__/graphics/entity/boiler/hr-boiler-E-light.png",
          priority = "extra-high",
          frame_count = 1,
          width = 139,
          height = 244,
          shift = util.by_pixel(0.25, -13),
          blend_mode = "additive",
          scale = 0.5
        }
      },
      south =
      {
        filename = "__WearAndTear__/graphics/entity/boiler/boiler-S-light.png",
        priority = "extra-high",
        frame_count = 1,
        width = 100,
        height = 81,
        shift = util.by_pixel(1, 5.5),
        blend_mode = "additive",
        hr_version = {
          filename = "__WearAndTear__/graphics/entity/boiler/hr-boiler-S-light.png",
          priority = "extra-high",
          frame_count = 1,
          width = 200,
          height = 162,
          shift = util.by_pixel(1, 5.5),
          blend_mode = "additive",
          scale = 0.5
        }
      },
      west =
      {
        filename = "__WearAndTear__/graphics/entity/boiler/boiler-W-light.png",
        priority = "extra-high",
        frame_count = 1,
        width = 68,
        height = 109,
        shift = util.by_pixel(2, -6.5),
        blend_mode = "additive",
        hr_version = {
          filename = "__WearAndTear__/graphics/entity/boiler/hr-boiler-W-light.png",
          priority = "extra-high",
          frame_count = 1,
          width = 136,
          height = 217,
          shift = util.by_pixel(2, -6.25),
          blend_mode = "additive",
          scale = 0.5
        }
      }
    }
    
  
data:extend({emitter_entity})
data:extend({emitter_item})

local emitter_closed_entity = util.table.deepcopy(data.raw["boiler"]["emitter"])

emitter_closed_entity.name = "emitter_closed"
emitter_closed_entity.energy_source.smoke = {}

local emitter_closed_item = util.table.deepcopy(data.raw.item["emitter"]) -- dummy item
emitter_closed_item.name = "emitter_closed"
emitter_closed_item.place_result = "emitter" -- needed something to place the opened version



data:extend({emitter_closed_entity})
data:extend({emitter_closed_item}) -- dummy item

