

data:extend(
{{
    type = "trivial-smoke",
    name = "smoke_Wear", color = {r = 0.8, g = 0.8, b = 0.8, a = 0.8},
    flags = {"not-on-map"},
    animation =
    {
      filename = "__base__/graphics/entity/smoke-fast/smoke-fast.png",
      priority = "high",
      width = 50,
      height = 50,
      frame_count = 16,
      animation_speed = 16 / 600,
      duration = 600,
      fade_away_duration = 600
    }
  },
  
  
    {
    type = "smoke-with-trigger",
    name = "wt-toxin-cloud",
    flags = {"not-on-map"},
    show_when_smoke_off = true,
    animation =
    {
      filename = "__WearAndTear__/graphics/entity/invisible_cloud.png",
      flags = { "compressed" },
      priority = "low",
      width = 1,
      height = 1,
      frame_count = 1,
      animation_speed = 0.5,
      line_length = 1,
      scale = 1,
    },
    slow_down_factor = 0,
    affected_by_wind = true,
    cyclic = true,
    duration = 15,
    fade_away_duration = 1,
    spread_duration = 1,
	radius = 10,
    color = { r = 0.2, g = 0.9, b = 0.2 },
    action =
    {
      type = "direct",
      action_delivery =
      {
        type = "instant",
        target_effects =		
        {
          type = "nested-result",
          action =
          {
            type = "area",
            perimeter = 6,
			radius = 3,
            entity_flags = {"breaths-air"},
            action_delivery =
            {
              type = "instant",
              target_effects =
              {
                type = "damage",
                damage = { amount = 8, type = "poison"}
              }
            }
          }
        }
      }
    },
    action_cooldown = 30
  },
  
  
    
      
  {
    type = "trivial-smoke",
    name = "mist-smoke", color = {r = 0.8, g = 0.34, b = 0.6, a = 0.2},
    flags = {"not-on-map"},
    duration = 600,
    fade_in_duration = 0,
    fade_away_duration = 600,
    spread_duration = 600,
    start_scale = 0.20,
    end_scale = 1.0,
    cyclic = true,
    affected_by_wind = true,
    animation = {
      width = 152,
      height = 120,
      line_length = 5,
      frame_count = 60,
      axially_symmetrical = false,
      direction_count = 1,
      shift = {-0.53125, -0.4375},
      priority = "high",
      animation_speed = 0.25,
      filename = "__base__/graphics/entity/smoke/smoke.png",
      flags = { "smoke" }
    }
    },
    
    
   {
    type = "fluid",
    name = "alien-steam",
    default_temperature = 15,
    max_temperature = 1000,
    heat_capacity = "0.2KJ",
    icon = "__WearAndTear__/graphics/icons/alien-steam.png",
    base_color = {r=0.8, g=0.34, b=0.6},
    flow_color = {r=.80, g=.34, b=.6},
    order = "a[fluid]-b[steam]",
    pressure_to_speed_ratio = 0.4,
    flow_to_energy_ratio = 0.59,
    gas_temperature = 15,
    auto_barrel = false
  },
  {
    type = "item",
    name = "scrap-metal",
    icon = "__WearAndTear__/graphics/icons/junk.png",
    flags= { "goes-to-main-inventory" },
    subgroup = "recycling",
    order = "b",
    stack_size = 800
  },
  {
    type = "item",
    name = "alien-goop",
    icon = "__WearAndTear__/graphics/icons/alien-artifact-goo.png",
    flags= { "goes-to-main-inventory" },
    subgroup = "intermediate-product",
    order = "zzzz[intermediate-product]",
    stack_size = 200
  },
 {
    type = "fluid",
    name = "liquified-goop",
    default_temperature = 25,
    max_temperature = 100,
    heat_capacity = "0.5KJ",
    base_color = {r=.50, g=0.34, b=0.6},
    flow_color = {r=0.50, g=0.34, b=0.6},
    icon = "__WearAndTear__/graphics/icons/liquid-goop.png",
    order = "zzzzz[liquified-goop]",
    pressure_to_speed_ratio = 0.4,
    flow_to_energy_ratio = 0.59
  },
   {
    type = "fluid",
    name = "alien-solution",
    default_temperature = 25,
    max_temperature = 100,
    heat_capacity = "0.5KJ",
    base_color = {r=.80, g=0.34, b=0.6},
    flow_color = {r=0.80, g=0.34, b=0.6},
    icon = "__WearAndTear__/graphics/icons/alien-solution.png",
    order = "zzzzz[liquified-goop]",
    pressure_to_speed_ratio = 0.4,
    flow_to_energy_ratio = 0.59
  },
   	{
    type = "item",
    name = "mister-void",
    icon = "__WearAndTear__/graphics/icons/alien-solution.png",
    flags = {"goes-to-main-inventory", "hidden"},
	subgroup = "intermediate-product",
    stack_size = 200
},
  {
    type = "item",
    name = "machinery_lubricant",
    icon = "__WearAndTear__/graphics/icons/lube.png",
    flags= { "goes-to-main-inventory" },
    subgroup = "intermediate-product",
    order = "zzzz[machinery_lubricant]",
    stack_size = 200
  },
   {
    type = "item",
    name = "spare_parts",
    icon = "__WearAndTear__/graphics/icons/universal_part.png",
    flags= { "goes-to-main-inventory" },
    subgroup = "intermediate-product",
    order = "zzzz[spare_parts]",
    stack_size = 200
  },
   {
    type = "item",
    name = "copper-dust",
    icon = "__WearAndTear__/graphics/icons/copper-dust.png",
    flags= { "goes-to-main-inventory" },
    subgroup = "intermediate-product",
    order = "zzzz[spare_parts]",
    stack_size = 200
  },
  
{
    type = "item",
    name = "maintenance",
    icon = "__WearAndTear__/graphics/icons/maintenance.png",
    flags= { "goes-to-main-inventory"},
    subgroup = "intermediate-product",
    order = "a[maintenance]",
    stack_size = 200
  },
{
    type = "explosion",
    name = "old_smoke",
 
    flags = {"not-on-map"},
    animations =
    {


      {
       filename = "__WearAndTear__/graphics/blank.png",
        priority = "extra-high",
        width =  1,
        height =  1,
        frame_count = 16,
        animation_speed = 0.5
      }
    },
    light = {intensity = 0, size = 20},
    smoke = "smoke_Wear",
    smoke_count =4,
    smoke_slow_down_factor = 1
    }
  
--  {
--    type = "explosion",
--    name = "vented_smoke",
 
--    flags = {"not-on-map"},
--    animations =
--    {


--      {
--       filename = "__WearAndTear__/graphics/blank.png",
--        priority = "extra-high",
--        width =  1,
--        height =  1,
--        frame_count = 16,
--        animation_speed = .0889
--      }
--    },
--    light = {intensity = 0, size = 20},
--    smoke = "mist-smoke",
--    smoke_count =12,
--    smoke_slow_down_factor = 1,
--    north_position = util.by_pixel(-38, -47.5),
--    south_position = util.by_pixel(38.5, -32),
--    east_position = util.by_pixel(20, -70),
--    west_position = util.by_pixel(-19, -8.5),
--    starting_vertical_speed = 0.08,
--    slow_down_factor = 1,          
--    starting_frame_deviation = 60,
--    frequency = 15
--    }
  }
)

 data:extend({
  {
    name = "vented_smoke",
    type = "trivial-smoke", 
    color = {r = 0.8, g = 0.34, b = 0.6, a = 0.2},
    flags = {"not-on-map"},
    start_scale = 0.2,
    end_scale = 1,
    duration = 600,
    fade_away_duration = 600,
    fade_in_duration = 0,
    spread_duration = 600,
    cyclic = true,
    affected_by_wind = true,
--    north_position = util.by_pixel(-38, -47.5),
--    south_position = util.by_pixel(38.5, -32),
--    east_position = util.by_pixel(20, -70),
--    west_position = util.by_pixel(-19, -8.5),
    starting_vertical_speed = 0.18,
    slow_down_factor = 1,
--    starting_frame_deviation = 60,
--    frequency = 15,
    animation = {
      width = 152,
      height = 120,
      line_length = 5,
      frame_count = 60,
      axially_symmetrical = false,
      direction_count = 1,
      shift = {-3, 2},
      priority = "high",
      animation_speed = 0.25,
      filename = "__base__/graphics/entity/smoke/smoke.png",
      flags = { "smoke" }    }

  }})
  
  
  