data:extend({

	{
		type = "double-setting",
		name = "aging_age",
		setting_type = "runtime-global",
		default_value = 30,
		maximum_value = 100000,
		minimum_value = 1,
		description = "aging_age",
		per_user = false,
		order = "a"
	},
	
	{
		type = "double-setting",
		name = "old_age",
		setting_type = "runtime-global",
		default_value = 120,
		maximum_value = 100000,
		minimum_value = 1,
		description = "old_age",
		per_user = false,
		order = "b"
	},
	{
		type = "double-setting",
		name = "dilapidated_age",
		setting_type = "runtime-global",
		default_value = 60,
		maximum_value = 100000,
		minimum_value = 1,
		description = "dilapidated_age",
		per_user = false,
		order = "c"
	},
	{
		type = "double-setting",
		name = "death_age",
		setting_type = "runtime-global",
		default_value = 60,
		maximum_value = 100000,
		minimum_value = 1,
		description = "death_age",
		per_user = false,
		order = "d"
	},
	{
		type = "double-setting",
		name = "idle_age",
		setting_type = "runtime-global",
		default_value = .06,
		maximum_value = 1,
		minimum_value = 0,
		description = "idle_age",
		per_user = false,
		order = "e"
	},
	{	
		type = "string-setting",
		name = "notifications",
		setting_type = "runtime-global",
		default_value = "on",
		allowed_values = {"on", "off", "scanner"},
		description = "notifications",
		per_user = false,
		order = "f"
	},
	{	
		type = "bool-setting",
		name = "smoke",
		setting_type = "runtime-global",
		default_value = true,
		description = "smoke",
		per_user = false,
		order = "g"
	},
	{	
		type = "string-setting",
		name = "when_to_replace",
		setting_type = "runtime-global",
		default_value = "old",
		allowed_values = {"old", "dilapidated_only", "never"},
		description = "when_to_replace",
		per_user = false,
		order = "h"
	},
	{	
		type = "bool-setting",
		name = "mining_drills_age",
		setting_type = "runtime-global",
		default_value = true,
		description = "mining_drills_age",
		per_user = false,
		order = "i"
	},
	{	
		type = "bool-setting",
		name = "crafting_machines_age",
		setting_type = "runtime-global",
		default_value = true,
		description = "crafting_machines_age",
		per_user = false,
		order = "j"
	},
	{	
		type = "bool-setting",
		name = "steam_engines_age",
		setting_type = "runtime-global",
		default_value = true,
		description = "steam_engines_age",
		per_user = false,
		order = "k"
	},
	{	
		type = "bool-setting",
		name = "solar_panels_age",
		setting_type = "runtime-global",
		default_value = true,
		description = "solar_panels_age",
		per_user = false,
		order = "l"
	},
	{	
		type = "bool-setting",
		name = "furnaces_age",
		setting_type = "runtime-global",
		default_value = true,
		description = "furnaces_age",
		per_user = false,
		order = "m"
	},
	{	
		type = "bool-setting",
		name = "explosive_endings",
		setting_type = "runtime-global",
		default_value = false,
		description = "explosive_endings",
		per_user = false,
		order = "n"
	},
	{
		type = "double-setting",
		name = "new_mod_speed",
		setting_type = "startup",
		default_value = 1.1,
		maximum_value = 10,
		minimum_value = 0,
		description = "new_mod_speed",
		order = "o"
	},
	{
		type = "double-setting",
		name = "aging_mod_speed",
		setting_type = "startup",
		default_value = 1,
		maximum_value = 10,
		minimum_value = 0,
		description = "aging_mod_speed",
		order = "p"
	},
	{
		type = "double-setting",
		name = "old_mod_speed",
		setting_type = "startup",
		default_value = .5,
		maximum_value = 10,
		minimum_value = 0,
		description = "old_mod_speed",
		order = "q"
	},
	{
		type = "double-setting",
		name = "dilapidated_mod_speed",
		setting_type = "startup",
		default_value = .1,
		maximum_value = 10,
		minimum_value = 0,
		description = "aging_mod_speed",
		order = "r"
	},
	{
		type = "double-setting",
		name = "new_mod_pollution",
		setting_type = "startup",
		default_value = .9,
		maximum_value = 10,
		minimum_value = 0,
		description = "new_mod_pollution",
		order = "s"
	},
	{
		type = "double-setting",
		name = "aging_mod_pollution",
		setting_type = "startup",
		default_value = 1,
		maximum_value = 10,
		minimum_value = 0,
		description = "aging_mod_pollution",
		order = "t"
	},
	{
		type = "double-setting",
		name = "old_mod_pollution",
		setting_type = "startup",
		default_value = 2,
		maximum_value = 10,
		minimum_value = 0,
		description = "old_mod_pollution",
		order = "u"
	},
	{
		type = "double-setting",
		name = "dilapidated_mod_pollution",
		setting_type = "startup",
		default_value = 5,
		maximum_value = 10,
		minimum_value = 0,
		description = "dilapidated_mod_pollution",
		order = "v"
	},
	{
		type = "bool-setting",
		name = "hide_refurbush_recipes",
		setting_type = "startup",
		default_value = false,
		description = "hide_refurbush_recipes",
		order = "w"
	}
})
